<script lang="ts">
    import { goto } from '$app/navigation';
    import { champions, families } from '$lib/tftData';
    import { writable } from 'svelte/store';
    import { onMount } from 'svelte';
    import { get } from 'svelte/store';
  
    export const championsStore = writable([]);
    
    let allChampions = [];
    let searchTerm = '';
    let selectedFamily = '';
    const filteredChampions = writable([]); // Utilisez un store Svelte pour la réactivité

  
    onMount(() => {
        const storedChampions = JSON.parse(localStorage.getItem('champions') || '[]');
        championsStore.set([...champions, ...storedChampions]);
        allChampions = [...champions, ...storedChampions];
        // Initialise filteredChampions avec tous les champions au montage
        filteredChampions.set(champions);
});
  
    function navigateToAddChampion() {
      goto('/champions/add/');
    }

    function navigate(url) {
    window.location.href = url;
  }
  

  function updateFilteredChampions() {
    if(selectedFamily) {
        filteredChampions.set(champions.filter(champion => 
        (selectedFamily ? champion.familyId === selectedFamily : true) &&
            champion.name.toLowerCase().includes(searchTerm.toLowerCase())
        ));
    } else {
        filteredChampions.set(champions.filter(champion => 
            champion.name.toLowerCase().includes(searchTerm.toLowerCase())
        ));
    }
    
}
$: selectedFamily, searchTerm, updateFilteredChampions();

</script>
  
  <div class="container mt-5">
    <h1>Liste des Champions</h1>
    
       
        <select class="form-select" bind:value={selectedFamily}>
            <option value="">Toutes les familles</option>
            {#each families as family}
                <option value={family.id}>{family.name}</option>
            {/each}
        </select>
        
    
      
    <button class="btn btn-primary mb-3" on:click={navigateToAddChampion}>Ajouter un Champion</button>
    <div class="row">
        {#if selectedFamily}
            {#each $filteredChampions as champion}
                <div class="col-sm-6 col-md-4 col-lg-3 mb-3" in:slide={{ delay: 200, duration: 300 }}>
                    <div class="card h-100 champion-card">
                        <img src={champion.image} class="card-img-top card-img-container" alt={champion.name}>
                        <div class="card-body">
                            <h5 class="card-title">{champion.name}</h5>
                            <p class="card-text">{champion.description}</p>
                            <a href={`/champions/${champion.name}`} class="btn btn-primary mt-2">En savoir plus</a>
                        </div>
                    </div>
                </div>
        {/each}
        {:else}
        {#each champions as champion}
          <!-- Affichage de tous les champions -->
          <div class="col-sm-6 col-md-4 col-lg-3 mb-3" in:slide={{ delay: 200, duration: 300 }}>
            <div class="card h-100 champion-card">
                <img src={champion.image} class="card-img-top card-img-container" alt={champion.name}>
                <div class="card-body">
                    <h5 class="card-title">{champion.name}</h5>
                    <p class="card-text">{champion.description}</p>
                    <a href={`/champions/${champion.name}`} class="btn btn-primary mt-2">En savoir plus</a>
                </div>
            </div>
        </div>
        {/each}
      {/if}
    </div>

    
    <p> Si rien ne s'affiche, rechargez la page. Il a dût se produire une erreur particulière</p>
  </div>
  
  <style>
    /* Styles supplémentaires au besoin */
  </style>
  